/***************************************************************************
**
** Copyright (C) 2015 Jochen Becher
** Contact: http://www.qt.io/licensing
**
** This file is part of Qt Creator.
**
** Commercial License Usage
** Licensees holding valid commercial Qt licenses may use this file in
** accordance with the commercial license agreement provided with the
** Software or, alternatively, in accordance with the terms contained in
** a written agreement between you and The Qt Company.  For licensing terms and
** conditions see http://www.qt.io/terms-conditions.  For further information
** use the contact form at http://www.qt.io/contact-us.
**
** GNU Lesser General Public License Usage
** Alternatively, this file may be used under the terms of the GNU Lesser
** General Public License version 2.1 or version 3 as published by the Free
** Software Foundation and appearing in the file LICENSE.LGPLv21 and
** LICENSE.LGPLv3 included in the packaging of this file.  Please review the
** following information to ensure the GNU Lesser General Public License
** requirements will be met: https://www.gnu.org/licenses/lgpl.html and
** http://www.gnu.org/licenses/old-licenses/lgpl-2.1.html.
**
** In addition, as a special exception, The Qt Company gives you certain additional
** rights.  These rights are described in The Qt Company LGPL Exception
** version 1.1, included in the file LGPL_EXCEPTION.txt in this package.
**
****************************************************************************/

#ifndef QMT_PROJECT_H
#define QMT_PROJECT_H

#include "qmt/infrastructure/uid.h"

#include <QString>


namespace qmt {

class MPackage;


class QMT_EXPORT Project
{
public:
    Project();

    ~Project();

    Uid getUid() const { return _uid; }

    void setUid(const Uid &uid);

    bool hasFileName() const;

    QString getFileName() const { return _file_name; }

    void setFileName(const QString &file_name);

    MPackage *getRootPackage() const { return _root_package; }

    void setRootPackage(MPackage *root_package);

private:

    Uid _uid;

    QString _file_name;

    MPackage *_root_package;
};

}

#endif // QMT_PROJECT_H
